import org.apache.bsf.*;   // import BSF support

public class TestSimpleExecJavaScript {

  public static void main (String[] args) throws java.io.IOException
  {
    try
    {
      BSFManager mgr    = new BSFManager ();
      BSFEngine  engine = mgr.loadScriptingEngine("javascript");
      String     code   = "java.lang.System.out.println(\"JavaScript was here!\")";
          // invoke the JavaScript script
      engine.exec ("javascript", 0, 0, code);
    }
    catch (BSFException e)
    {
      e.printStackTrace();
    }
  }
}

