/* ---rgf, 2003-07-25 */

-- nr=random(3,10)
nr=3
say left( "creating" pp(nr) "threads ", 75, "=")

.local~mainTID=bsfgetTID() -- save TID of main thread

do i=1 to nr
   .test~new
end

-- .local~mainTID=bsfgetTID() -- save TID of main thread

say center(" main Rexx thread, TID:" bsfgetTID() "==" .mainTID "", 79, "~")
say left( "done creating" pp(nr) "threads ", 75, "=")
say center(" exiting main Object Rexx thread ", 79, "*")
-- say 1/0  -- displays arithmetic error, but execution of threads proceeds !
-- say "oha!"
say "--> "~copies(15)
-- call sysSleep 2   -- <<<--- without this ooRexx 3.2.0 falls over its own feet (probably in RXSIO)
                     -- if invoked via Java (BSF)
say "<-- "~copies(15)


::requires BSF.CLS


::class test
::method init class
  expose counter
  counter=0

::method counter class
  expose counter
  counter=counter+1
  return counter

::method init
  expose idnr
  idnr=self~class~counter  -- assign a unique counter
  say "tid" pp(idnr "/" bsfGetTID()) "before 'reply' and then 'self~giveFeedback'..."
  reply
  self~giveFeedback

::method giveFeedback
  expose idnr

  sleeptime=format(random(500, 1500)/1000,,3)
  start=pp(date("s") time("L"))
  say "tid" pp(idnr "/" bsfGetTID()) start "sleeps" pp(sleeptime) "seconds"
--  if .mainTID <> bsfGetTID() then
  do
     -- say "---> attaching tid ["idnr "/" bsfGetTID()"] to TID [".mainTID"], executed? ["||bsfAttachToTID(.mainTID)"]"

     -- 2004-01-23, ---rgf
     say "---> attaching tid ["idnr "/" bsfGetTID()"] to TID [".mainTID"], successful? ["||bsfAttachToTID(.mainTID)"]"
  end
  -- call sysSleep sleeptime
  call bsf "sleep", sleeptime
  end=pp(date("s") time("L"))
  say "tid" pp(idnr "/" bsfGetTID()) "AWOKE!" start"+"pp(sleeptime) "=" end
  say left("tid" pp(idnr "/" bsfGetTID()) "the end ", 70, "-")

  self~sleepAgain
  self~indicateEnd

::method sleepAgain
  expose idnr
  say "+++"
  say left("tid" pp(idnr "/" bsfGetTID()) "SLEEPING again, immediately! ... ", 70, "-")
  sleeptime=format(random(500, 1500)/1000,,3)
  start=pp(date("s") time("L"))
  say "tid" pp(idnr "/" bsfGetTID()) start "sleeps" pp(sleeptime) "seconds"
  -- call sysSleep sleeptime
  call bsf "sleep", sleeptime
  end=pp(date("s") time("L"))
  say "tid" pp(idnr "/" bsfGetTID()) "AWOKE!" start"+"pp(sleeptime) "=" end
  say left("tid" pp(idnr "/" bsfGetTID()) "the end ", 70, "-")

::method indicateEnd
  expose idnr
  say left("tid" pp(idnr "/" bsfGetTID()) "... indicateEnd-method ... ", 70, "-")



::method uninit
  expose idnr

  say left("tid" pp(idnr "/" bsfGetTID()) "//// destroying Object Rexx instance BEGIN! ", 70, "-")
  sleeptime=format(random(500, 1500)/1000,,3)
  start=pp(date("s") time("L"))
  say "tid" pp(idnr) start "sleeps" pp(sleeptime) "seconds"
  -- call sysSleep sleeptime
  call bsf "sleep", sleeptime
  end=pp(date("s") time("L"))
  say "tid" pp(idnr "/" bsfGetTID()) "AWOKE!" start"+"pp(sleeptime) "=" end

  say left("tid" pp(idnr "/" bsfGetTID()) "destroying Object Rexx instance END! \\\\ ", 70, "-")



::routine pp
  return "[" || arg(1) || "]"
