-- ooRexx 3.2.0: if not sleeping, then sometimes the requires is *not* resolved yet!!
-- call sysSleep .001
use arg threadName, maxSleepTime=2

-- say ".bsf4rexx          ="pp(.bsf4rexx)
-- say ".bsf4rexx~dir      ="pp(.bsf4rexx~dir)
-- say ".bsf4rexx~dir~items="pp(.bsf4rexx~dir~items)
-- say ".bsf4rexx~items    ="pp(.bsf4rexx~items)
say "* REXX-START: threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())~left(10) -
              ".bsf4rexx~items="pp(.bsf4rexx~items) -
              ".bsf4rexx~identityHash="pp(.bsf4rexx~identityHash) -
              ".loc="pp(.local~identityHash) -
              ".env="pp(.environment~identityHash)
.bsf4rexx~setEntry(threadName"[begin]", bsfGetTid())

a1="| Rexx->begin: threadName="pp(threadName)"/[@threadName]" ".loc="pp(.local~identityHash) -
        ".env="pp(.environment~identityHash) ".b4r="pp(.b4r~identityHash) "tid="||bsfGetTID()

-- say "-->"
-- say ".bsf4rexx~hasIndex="pp(.bsf4rexx~hasIndex)
-- say ".bsf4rexx~hasIndex('aha')="pp(.bsf4rexx~hasIndex('aha'))
-- say ".bsf4rexx~hasIndex('int')="pp(.bsf4rexx~hasIndex('int'))
-- say ".bsf4rexx~hasIndex('Integer')="pp(.bsf4rexx~hasIndex('Integer'))
-- say ".bsf4rexx~hasIndex('Integer.class')="pp(.bsf4rexx~hasIndex('Integer.class'))
-- say "<--"
-- say ".bsf4rexx~dir~hasIndex="pp(.bsf4rexx~dir~hasIndex)
-- say ".bsf4rexx~dir~hasIndex('aha')="pp(.bsf4rexx~dir~hasIndex('aha'))
-- say ".bsf4rexx~dir~hasIndex('int')="pp(.bsf4rexx~dir~hasIndex('int'))
-- say ".bsf4rexx~dir~hasIndex('Integer')="pp(.bsf4rexx~dir~hasIndex('Integer'))
-- say ".bsf4rexx~dir~hasIndex('Integer.class')="pp(.bsf4rexx~dir~hasIndex('Integer.class'))

if .bsf4rexx~hasIndex("aha") then
   .bsf4rexx~aha=.bsf4rexx~aha
else
   .bsf4rexx~aha=bsfGetTID()


say "threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())~left(10) "Hello from Rexx!" .dateTime~new getInfo()

j1v="#1 java.version="pp(.java.lang.system~getProperty('java.version'))
j2v="#2 java.version="pp(.bsf4rexx~system.class~getProperty('java.version'))

say "threadName="pp(threadName) "TID:" pp(bsfGetTID())~left(10) -
                 j1v -
                 j2v -
                 j3v -
                 .dateTime~new getInfo()

jo=.bsf~new("java.util.HashMap")
say "jo="jo

call time "R"
do while time("E")<maxSleepTime
   sleepTime=random(1,trunc(1000*maxSleepTime/3))/1000  -- make sure we yield at least three times
   sleepTime=format(sleepTime, , 3)
   say "threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())~left(10) "Sleeping" pp(sleepTime) "sec(s)..." .dateTime~new -- getInfo()
a2="| Rexx->middle: threadName="pp(threadName)"/[@threadName]" ".loc="pp(.local~identityHash) -
        ".env="pp(.environment~identityHash) ".b4r="pp(.b4r~identityHash) "tid="||bsfGetTID()
   call sysSleep sleepTime
end
a3="| Rexx->end: threadName="pp(threadName)"/[@threadName]" ".loc="pp(.local~identityHash) -
        ".env="pp(.environment~identityHash) ".b4r="pp(.b4r~identityHash) "tid="||bsfGetTID()

.bsf4rexx~setEntry(threadName"[end]", bsfGetTid())

res="///" pp("threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())) ".b4r~idHa="pp(.bsf4rexx~identityHash) ".bsf4rexx~aha="pp(.bsf4rexx~aha) pp(.bsf4rexx~aha~identityHash) j1v a1 a2 a3 .dateTime~new "\\\"

-- res=pp("threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())) .dateTime~new "///" getBSF4RexxStuff()   "\\\"
res=pp("threadName="pp(threadName)"/[@threadName]" "TID:" pp(bsfGetTID())) .dateTime~new "///" getInfo()   "\\\"
say "  * Rexx:" res

return res


::requires bsf.cls
::requires rgf_util2.rex

::routine  getInfo
  return ".bsf4rexx~identityHash="pp(.bsf4rexx~identityHash) "bsf('getBsfManager')="pp(bsf('getBsfManager'))

::routine  getInfo2
  return ".bsf4rexx~system.class="pp(.bsf4rexx~system.class) "bsf('getBsfManager')="pp(bsf('getBsfManager'))

::routine getBSF4RexxStuff
  arr=sort2(.bsf4rexx~dir, "I")
say "arr="pp(arr) "arr~class="pp(arr~class)
  tmpStr=""
  oldVal=""
  do idx over arr
     -- if pos("THREAD-",idx)=0 then iterate

     if tmpStr<>"" then
        tmpStr=tmpStr"/"

     newVal=.bsf4rexx[idx]

     tmpStr=tmpStr || idx"="pp(.bsf4rexx[idx])
     if oldVal=newVal then
        tmpStr=tmpStr" | "

     oldVal=newVal
  end
  return tmpStr


