/* ---rgf, 2001-06-04, test Object Rexx threads pumping eventTexts asynchroneously ... */

/*
if rxFuncQuery("BSF") then  /* no bsf4rexx support available yet, hence load Java */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs    /* load all BSF-functions                    */
   call BsfLoadJava     /* load the JVM and set up BSF4Rexx-support  */
end
*/

if      BsfInvokedBy()=1 then say "This Rexx program was invoked by Java!"
else if BsfInvokedBy()=2 then say "This Rexx program was invoked by Rexx, JVM loaded by Rexx!"
else                          say "No JVM present, we got troubles ..."

Say "Playing 'counting to three' ..."
endToken="finish!"
.eventPump~new("German ", .array~of("eins", "zwei", "drei",  endToken), 0 )
.eventPump~new("Italia ", .array~of("uno",  "due",  "tre",   ),  1 )
.eventPump~new("English", .array~of("one",  "two",  "three"  ),  2 )
.eventPump~new("France ", .array~of("un",   "deux", "trois"  ),  1 )
.eventPump~new("Spanish", .array~of("un",   "dos",  "tres"   ),  2 )

sleep=5
say "sleeping" sleep "secs before starting to dispatch..."
call syssleep sleep
tab="09"x
say pp(time('L')) "- starting to dispatch event texts ..."
do forever
   txt = bsf.pollEventText(100)
   say tab pp(txt)
   if word(txt,1)=endToken then leave
end
say pp(time('L')) "- received endToken" pp(endToken)", stopped."


::requires BSF.CLS -- get Object Rexx support for BSF4Rexx

::routine pp
  return "[" || arg(1)~string || "]"

-- class to asynchroneously and intermittently pump eventTexts ..
::class eventPump
::method init
  use arg lang, eventText, level
  level=min(max(0,level), 2)    -- make sure level is 0, 1, 2
  tid=BsfGetTID()    -- get main TID
  reply
  say "BSFAttachToTID("tid"):" BSFAttachToTID(tid)
  say 'Pumping' pp(lang) 'at level' pp(level) '...'

        -- now give randomizer a seed to make sure sleeping times are independent
  numeric digits 20
  -- tmp=random(,,eventText~"=="~c2x~x2d//999999)       -- seed  -- incompatible in ooRexx 4.0 (rgf, 2009-03-20) :-(
  tmp=random(,,eventText~identityHash//999999)       -- seed
  do item over eventText
     sleepTime = random(0,500)/1000
     say pp(lang) "sleeping" pp(sleepTime) "seconds."
     call sysSleep random(0,500)/1000   -- sleep a while
     say pp(lang) bsf 'postEventText,' item~left(7,".") 'level:' pp(level) time('L')"," level   -- add eventText to level
     call bsf 'postEventText', item~left(7,".") 'level:' pp(level) time('L'), level   -- add eventText to level
     say pp(lang) "suceeded!"
  end

