#!/usr/bin/rexx
-- 2008-09-09: testing a few new methods/functions

call uno.cls

ad=uno.createDesktop()  /* creates and returns a desktop service object */
say "ad="pp(ad)

say "ad~uno.getInterfaceName:    " pp(ad~uno.getInterfaceName)
say "ad~uno.queryServiceName():  " pp(ad~uno.queryServiceName("frame"))
say "ad~uno.supportsService():   " pp(ad~uno.supportsService("frame"))
say "ad~uno.queryInterfaceName():" pp(ad~uno.queryInterfaceName("xpropertyset"))
say "ad~uno.supportsInterface(): " pp(ad~uno.supportsInterface("xpropertyset"))
say "... supplying non existent names:"
say "ad~uno.queryServiceName():  " pp(ad~uno.queryServiceName("framex"))
say "ad~uno.supportsService():   " pp(ad~uno.supportsService("framex"))
say "ad~uno.queryInterfaceName():" pp(ad~uno.queryInterfaceName("xpropertysetx"))
say "ad~uno.supportsInterface(): " pp(ad~uno.supportsInterface("xpropertysetx"))
say "--"
say "uno.getInterfaceName():     " pp(uno.getInterfaceName(ad))
say "uno.queryServiceName():     " pp(uno.queryServiceName(ad,"frame"))
say "uno.supportsService():      " pp(uno.supportsService(ad,"frame"))
say "uno.queryInterfaceName():   " pp(uno.queryInterfaceName(ad,"xpropertyset"))
say "uno.supportsInterface():    " pp(uno.supportsInterface(ad,"xpropertyset"))
say "... supplying non existent names:"
say "uno.getInterfaceName():     " pp(uno.getInterfaceName(ad))
say "uno.queryServiceName():     " pp(uno.queryServiceName(ad,"framex"))
say "uno.supportsService():      " pp(uno.supportsService(ad,"framex"))
say "uno.queryInterfaceName():   " pp(uno.queryInterfaceName(ad,"xpropertysetx"))
say "uno.supportsInterface():    " pp(uno.supportsInterface(ad,"xpropertysetx"))
say "--"

say "implemented service names:  " ppd(ad~uno.getServiceNames)
say "--"

say "implemented interface names:" ppd(ad~uno.getInterfaceNames)
say "--"

say "properties:" ppd(ad~uno.getProperties)
say "--"

bd=ad~XDesktop          /* queries the "com.sun.star.frame.XDestkop" interface */
cd=bd~XPropertySet      /* queries the "com.sun.star.beans.XPropertySet" interface */
say ad~toString         /* ask the proxy for its string representation */
parse value ad~toString with . "Type["type"]" .;say type"."

say bd~toString         /* ask the proxy for its string representation */
parse value bd~toString with "Type["type"]";say type"."

say cd~toString         /* ask the proxy for its string representation */
parse value cd~toString with "Type["type"]";say type"."

say ad~uno.getTypeName bd~uno.getTypeName cd~uno.getTypeName  /* get the IDL type name via reflection */
say uno.areSame(ad,bd) uno.areSame(bd,cd) uno.areSame(ad,cd)     /* test whether all three are the same object */

parse value cd~toString with "Type[" type "]";say type"."

